/********************************************************
** Copyright 1999 Earth Resource Mapping Pty Ltd.
** This document contains unpublished source code of
** Earth Resource Mapping Pty Ltd. This notice does
** not indicate any intention to publish the source
** code contained herein.
**
** FILE:   	NCSHelpContextID.h
** CREATED:	Mon June 25 09:19:00 WST 2000
** AUTHOR: 	Mark Sheridan
** PURPOSE:	Map context id's for the help system to methods
**			int the idl for NCSViewMgr and ECW libraries.
** EDITS:
 *******************************************************/

// Top level ID's
#define IDH_NCS_ACTIVEX_HOME		0x00001000

// Method IDs for the NCSRenderer object
#define IDH_NCSREND_HOME					0x00001001
#define IDH_NCSREND_OPEN					0x00001002
#define IDH_NCSREND_CLOSE					0x00001003
#define IDH_NCSREND_TRANSPARENT				0x00001004
#define IDH_NCSREND_BACKCLR					0x00001005
#define IDH_NCSREND_FILENAME				0x00001006
#define IDH_NCSREND_WIDTH					0x00001007
#define IDH_NCSREND_HEIGHT					0x00001008
#define IDH_NCSREND_NRBANDS					0x00001009
#define IDH_NCSREND_CMPRATIO				0x00001010
#define IDH_NCSREND_CELLX					0x00001011
#define IDH_NCSREND_CELLY					0x00001012
#define IDH_NCSREND_ORIGINX					0x00001013
#define IDH_NCSREND_ORIGINY					0x00001014
#define IDH_NCSREND_PROJECTION				0x00001015
#define IDH_NCSREND_DATUM					0x00001016
#define IDH_NCSREND_SETVIEW					0x00001017
#define IDH_NCSREND_READIMAGE				0x00001018
#define IDH_NCSREND_DRAWIMAGE				0x00001019
#define IDH_NCSREND_FIREREFRESH				0x00001020
#define IDH_NCSREND_READLINERGB				0x00001021
#define IDH_NCSREND_READLINEBGR				0x00001022
#define IDH_NCSREND_READLINEBIL				0x00001023
#define IDH_NCSREND_PROGRESSIVE				0x00001024
#define IDH_NCSREND_CELLUNITS				0x00001025
#define IDH_NCSREND_WRITEJPG				0x00001026
#define IDH_NCSREND_REFRESHUPDATE			0x00001027
#define IDH_NCSREND_GETPERCENTCOMPLETE		0x00001028
#define IDH_NCSREND_CONVERTWORLDTODATASET	0x00001029
#define IDH_NCSREND_CONVERTDATASETTOWORLD	0x00001030
#define IDH_NCSREND_FORMATERRORTEXT			0x00001031
#define IDH_NCSREND_BANDS					0x00001032
#define IDH_NCSREND_INFOTOPX				0x00001033
#define IDH_NCSREND_INFOLEFTY				0x00001034
#define IDH_NCSREND_BOTTOMX					0x00001035
#define IDH_NCSREND_RIGHTY					0x00001036
#define IDH_NCSREND_WINDOWSIZEX				0x00001037
#define IDH_NCSREND_WINDOWSIZEY				0x00001038
#define IDH_NCSREND_BLOCKSINVIEW			0x00001039
#define IDH_NCSREND_BLOCKSAVAILABLE			0x00001040
#define IDH_NCSREND_BLAOCKSAVAILATSETVIEW	0x00001041
#define IDH_NCSREND_MISSEDBLOCKS			0x00001042
#define IDH_NCSREND_WORLDTOPX				0x00001043
#define IDH_NCSREND_WORLDLEFTY				0x00001044
#define IDH_NCSREND_WORLDBOTTOMX			0x00001045
#define IDH_NCSREND_WORLDBOTTOMY			0x00001046
#define IDH_NCSREND_BANDLIST				0x00001047
#define IDH_NCSREND_IMAGEHEIGHT				0x00001048
#define IDH_NCSREND_IMAGEWIDTH				0x00001049

// Method IDs for the NCSView object
#define IDH_NCSVIEW_HOME					0x00002000
#define IDH_NCSVIEW_OPEN					0x00002001
#define IDH_NCSVIEW_ATTACH					0x00002002
#define IDH_NCSVIEW_SETEXTENTS				0x00002003
#define IDH_NCSVIEW_SETEXTENTSALL			0x00002004
#define IDH_NCSVIEW_REFRESH					0x00002005
#define IDH_NCSVIEW_COMPLETE				0x00002006
#define IDH_NCSVIEW_POINTERMODE				0x00002007
#define IDH_NCSVIEW_PROJECTION				0x00002008
#define IDH_NCSVIEW_DATUM					0x00002009
#define IDH_NCSVIEW_FILENAME				0x00002010
#define IDH_NCSVIEW_GEOLINKMODE				0x00002011
#define IDH_NCSVIEW_CELLX					0x00002012
#define IDH_NCSVIEW_CELLY					0x00002013
#define IDH_NCSVIEW_IMAGEX					0x00002014
#define IDH_NCSVIEW_IMAGEY					0x00002015
#define IDH_NCSVIEW_CELLUNITS				0x00002016
#define IDH_NCSVIEW_TLXWORLD				0x00002017
#define IDH_NCSVIEW_TLYWORLD				0x00002018
#define IDH_NCSVIEW_BRXWORLD				0x00002019
#define IDH_NCSVIEW_BRYWORLD				0x00002020
#define IDH_NCSVIEW_IMAGETLXWORLD			0x00002021
#define IDH_NCSVIEW_IMAGETLYWORLD			0x00002022
#define IDH_NCSVIEW_IMAGEBRXWORLD			0x00002023
#define IDH_NCSVIEW_IMAGEBRYWORLD			0x00002024
#define IDH_NCSVIEW_VISIMAGETLXWORLD		0x00002025
#define IDH_NCSVIEW_VISIMAGETLYWORLD		0x00002026
#define IDH_NCSVIEW_VISIMAGEBRXWORLD		0x00002027
#define IDH_NCSVIEW_VISIMAGEBRYWORLD		0x00002028
#define IDH_NCSVIEW_DETACH					0x00002029
#define IDH_NCSVIEW_CONVERTTOLATLONG		0x00002030
#define IDH_NCSVIEW_CONVERTTOEN				0x00002031
#define IDH_NCSVIEW_VERSIONSTRING			0x00002032
#define IDH_NCSVIEW_COORDLAT				0x00002033
#define IDH_NCSVIEW_COORDLONG				0x00002034
#define IDH_NCSVIEW_VIEWWIDTH				0x00002035
#define IDH_NCSVIEW_VIEWHEIGHT				0x00002036
#define IDH_NCSVIEW_LASTERRORTEXT			0x00002037
#define IDH_NCSVIEW_OPENEX					0x00002038
#define IDH_NCSVIEW_COORDEASTING			0x00002039
#define IDH_NCSVIEW_COORDNORTHING			0x00002040
#define IDH_NCSVIEW_ONMOUSEDOWNJS			0x00002041
#define IDH_NCSVIEW_ONMOUSEUPJS				0x00002042
#define IDH_NCSVIEW_ONMOUSEMOVEJS			0x00002043
#define IDH_NCSVIEW_ONEXTCHANGEJS			0x00002044
#define IDH_NCSVIEW_EVENT_EXTENTCHANGE		0x00002045
#define IDH_NCSVIEW_EVENT_POINTERMODECHANGE	0x00002046
#define IDH_NCSVIEW_EVENT_GEOLINKCHANGE		0x00002047
#define IDH_NCSVIEW_EVENT_PERCENTCOMP		0x00002048
#define IDH_NCSVIEW_EVENT_CLICK				0x00002049
#define IDH_NCSVIEW_EVENT_DBLCLICK			0x00002050
#define IDH_NCSVIEW_EVENT_MOUSEDOWN			0x00002051
#define IDH_NCSVIEW_EVENT_MOUSEUP			0x00002052
#define IDH_NCSVIEW_EVENT_MOUSEMOVE			0x00002053
#define IDH_NCSVIEW_EVENT_KEYDOWN			0x00002054
#define IDH_NCSVIEW_EVENT_KEYUP				0x00002055
#define IDH_NCSVIEW_ONGEOLINKMODECHANGEJS	0x00002056
#define IDH_NCSVIEW_ONPOINTERMODECHANGEJS	0x00002057
#define IDH_NCSVIEW_ONPERCENTCOMPMODECHANGEJS 0x00002058
#define IDH_NCSVIEW_CLOSE					0x00002059
#define IDH_NCSVIEW_OPEN_OVERLAY			0x00002060
#define IDH_NCSVIEW_CLOSE_OVERLAY			0x00002061
#define IDH_NCSVIEW_SET_OVERLAY_INFO		0x00002062
#define IDH_NCSVIEW_GET_OVERLAY_INFO		0x00002063
#define IDH_NCSVIEW_GET_OVERLAY_RGB			0x00002064
#define IDH_NCSVIEW_ONOVERLAYRESPONSEJS		0x00002065
#define IDH_NCSVIEW_GET_OVERLAY_INDEX		0x00002066
#define IDH_NCSVIEW_SET_BACKGROUND_COLOR	0x00002067
#define IDH_NCSVIEW_GET_VIEW_TOPLEFTX		0x00002068
#define IDH_NCSVIEW_GET_VIEW_TOPLEFTY		0x00002069
#define IDH_NCSVIEW_GET_OVERLAY_NAME		0x00002070
#define IDH_NCSVIEW_SET_GDT_SERVER			0x00002071
#define IDH_NCSVIEW_USE_GDT_DOWNLOADING		0x00002072
#define IDH_NCSVIEW_ONDRAWBEGIN				0x00002073
#define IDH_NCSVIEW_ONDRAWEND				0x00002074

//Method IDs for the NCSLayeredView object
#define IDH_NCSVIEW_OPEN_LAYER				0x00002300
#define IDH_NCSVIEW_CLOSE_LAYER				0x00002301
#define IDH_NCSVIEW_SET_LAYER_INFO			0x00002302
#define IDH_NCSVIEW_GET_LAYER_INFO			0x00002303
#define IDH_NCSVIEW_GET_LAYER_RGB			0x00002304
#define IDH_NCSVIEW_ONLAYERRESPONSEJS		0x00002305
#define IDH_NCSVIEW_GET_LAYER_INDEX			0x00002306

//Method IDs for the NCSGdt object
#define IDH_NCSGDT_HOME						0x00003000
#define IDH_NCSGDT_METREFACTOR_UNIT			0x00003001
#define IDH_NCSGDT_UNITS_FROMMETREFACTOR	0x00003002
#define IDH_NCSGDT_UNITS_FROMDATUMPROJ		0x00003003
#define IDH_NCSGDT_METREFACTOR_DATUMPROJ	0x00003004
#define IDH_NCSGDT_SERVERPATH				0x00003005
#define IDH_NCSGDT_SOURCECS					0x00003006
#define IDH_NCSGDT_DESTINATIONCS			0x00003007
#define IDH_NCSGDT_TRANFORMMODE				0x00003008
#define IDH_NCSGDT_TRANSFORM				0x00003009
#define IDH_NCSGDT_TRANSFORMVB				0x00003010

